/*           Par Michel DROUI. (Pseudo Internet : Nulentout.)
>>>>>> Si vous rencontrez un problème : michel.droui@laposte.net

Test de pilotage d'un Servomoteur par gestion angulaire.
Un potentiomètre sur l'entrés analogique A5 génère la valeur de l'angle de commande.
Utilise la librairie Servo.h fournie d'origine dans l'IDE.

Notez que pour cette manipulation l'entrée utilisée et la sortie PWM n'ont été sélectionnés sur aucun
      critère précis. C'est sur le programme complet que sera conduite l'analyse d'optimisation.
          
DIFFERENTS BRANCHEMENTS :
  D10 : Sortie_PWM
   A5 : Entree_mesuree                  
 D12 : xxx
 D13 : LED_Arduino
 
                                                                PGM               RAM dynamique
 PGM avec pilotage potentiométrique                       4590 Octets (14%)      234 Octets (11%)    */

//--------------------- Définition des broches d'E/S ------------------------
#define Sortie_PWM 10  // Broche PWM 10 utilisée.
#define Entree_mesuree 5 // Entrée analogique A5 utilisée.

//------------------------ Constantes du programme --------------------------

//------------------------- Variables du programme --------------------------
byte CNA_binaire; // Conversion sur un octet.
float CNA; // Mesure analogique retournée par le CNA.
//  Attention : Déclarer en float et non en byte, car
//  les décimales affichées seraient des zéros.

//-------------------------- Fin des déclarations ---------------------------

#include <Servo.h>
Servo ServoMoteur; // Identificateur du moteur.

void setup() {
   ServoMoteur.attach(10); // Servo commandé par la PWM 10.
   Serial.begin(115200);
}

void loop() {
  CNA = analogRead(Entree_mesuree); // Sens direct pour les moteurs SG90.
  CNA_binaire = CNA / 5.68; // Génère une valeur comprise entre 0 et 180.
  // Ci dessus : 1023 / 180 = 5,6833333.
  ServoMoteur.write(CNA_binaire); // Transmet la consigne au servomoteur.
  Serial.println(90-CNA_binaire); // Affiche la valeur de la consigne sur la ligne USB.
}
